// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from bosch_locator_bridge:msg/ClientRecordingVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_RECORDING_VISUALIZATION__FUNCTIONS_H_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_RECORDING_VISUALIZATION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "bosch_locator_bridge/msg/rosidl_generator_c__visibility_control.h"

#include "bosch_locator_bridge/msg/detail/client_recording_visualization__struct.h"

/// Initialize msg/ClientRecordingVisualization message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * bosch_locator_bridge__msg__ClientRecordingVisualization
 * )) before or use
 * bosch_locator_bridge__msg__ClientRecordingVisualization__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__msg__ClientRecordingVisualization__init(bosch_locator_bridge__msg__ClientRecordingVisualization * msg);

/// Finalize msg/ClientRecordingVisualization message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__msg__ClientRecordingVisualization__fini(bosch_locator_bridge__msg__ClientRecordingVisualization * msg);

/// Create msg/ClientRecordingVisualization message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * bosch_locator_bridge__msg__ClientRecordingVisualization__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bosch_locator_bridge__msg__ClientRecordingVisualization *
bosch_locator_bridge__msg__ClientRecordingVisualization__create();

/// Destroy msg/ClientRecordingVisualization message.
/**
 * It calls
 * bosch_locator_bridge__msg__ClientRecordingVisualization__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__msg__ClientRecordingVisualization__destroy(bosch_locator_bridge__msg__ClientRecordingVisualization * msg);

/// Check for msg/ClientRecordingVisualization message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__msg__ClientRecordingVisualization__are_equal(const bosch_locator_bridge__msg__ClientRecordingVisualization * lhs, const bosch_locator_bridge__msg__ClientRecordingVisualization * rhs);

/// Copy a msg/ClientRecordingVisualization message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__msg__ClientRecordingVisualization__copy(
  const bosch_locator_bridge__msg__ClientRecordingVisualization * input,
  bosch_locator_bridge__msg__ClientRecordingVisualization * output);

/// Initialize array of msg/ClientRecordingVisualization messages.
/**
 * It allocates the memory for the number of elements and calls
 * bosch_locator_bridge__msg__ClientRecordingVisualization__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__init(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array, size_t size);

/// Finalize array of msg/ClientRecordingVisualization messages.
/**
 * It calls
 * bosch_locator_bridge__msg__ClientRecordingVisualization__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__fini(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array);

/// Create array of msg/ClientRecordingVisualization messages.
/**
 * It allocates the memory for the array and calls
 * bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence *
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__create(size_t size);

/// Destroy array of msg/ClientRecordingVisualization messages.
/**
 * It calls
 * bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
void
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__destroy(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array);

/// Check for msg/ClientRecordingVisualization message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__are_equal(const bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * lhs, const bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * rhs);

/// Copy an array of msg/ClientRecordingVisualization messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_bosch_locator_bridge
bool
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__copy(
  const bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * input,
  bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_RECORDING_VISUALIZATION__FUNCTIONS_H_
