// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientControlMode.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_control_mode__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
bosch_locator_bridge__msg__ClientControlMode__init(bosch_locator_bridge__msg__ClientControlMode * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    bosch_locator_bridge__msg__ClientControlMode__fini(msg);
    return false;
  }
  // visual_recording_state
  // map_state
  // localization_state
  // recording_state
  // alignment_state
  // mask_state
  // expandmap_state
  return true;
}

void
bosch_locator_bridge__msg__ClientControlMode__fini(bosch_locator_bridge__msg__ClientControlMode * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // visual_recording_state
  // map_state
  // localization_state
  // recording_state
  // alignment_state
  // mask_state
  // expandmap_state
}

bool
bosch_locator_bridge__msg__ClientControlMode__are_equal(const bosch_locator_bridge__msg__ClientControlMode * lhs, const bosch_locator_bridge__msg__ClientControlMode * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // visual_recording_state
  if (lhs->visual_recording_state != rhs->visual_recording_state) {
    return false;
  }
  // map_state
  if (lhs->map_state != rhs->map_state) {
    return false;
  }
  // localization_state
  if (lhs->localization_state != rhs->localization_state) {
    return false;
  }
  // recording_state
  if (lhs->recording_state != rhs->recording_state) {
    return false;
  }
  // alignment_state
  if (lhs->alignment_state != rhs->alignment_state) {
    return false;
  }
  // mask_state
  if (lhs->mask_state != rhs->mask_state) {
    return false;
  }
  // expandmap_state
  if (lhs->expandmap_state != rhs->expandmap_state) {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientControlMode__copy(
  const bosch_locator_bridge__msg__ClientControlMode * input,
  bosch_locator_bridge__msg__ClientControlMode * output)
{
  if (!input || !output) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // visual_recording_state
  output->visual_recording_state = input->visual_recording_state;
  // map_state
  output->map_state = input->map_state;
  // localization_state
  output->localization_state = input->localization_state;
  // recording_state
  output->recording_state = input->recording_state;
  // alignment_state
  output->alignment_state = input->alignment_state;
  // mask_state
  output->mask_state = input->mask_state;
  // expandmap_state
  output->expandmap_state = input->expandmap_state;
  return true;
}

bosch_locator_bridge__msg__ClientControlMode *
bosch_locator_bridge__msg__ClientControlMode__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientControlMode * msg = (bosch_locator_bridge__msg__ClientControlMode *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientControlMode), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientControlMode));
  bool success = bosch_locator_bridge__msg__ClientControlMode__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientControlMode__destroy(bosch_locator_bridge__msg__ClientControlMode * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__msg__ClientControlMode__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__msg__ClientControlMode__Sequence__init(bosch_locator_bridge__msg__ClientControlMode__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientControlMode * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__msg__ClientControlMode *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__msg__ClientControlMode), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientControlMode__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientControlMode__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientControlMode__Sequence__fini(bosch_locator_bridge__msg__ClientControlMode__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientControlMode__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientControlMode__Sequence *
bosch_locator_bridge__msg__ClientControlMode__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientControlMode__Sequence * array = (bosch_locator_bridge__msg__ClientControlMode__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientControlMode__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientControlMode__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientControlMode__Sequence__destroy(bosch_locator_bridge__msg__ClientControlMode__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__msg__ClientControlMode__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__msg__ClientControlMode__Sequence__are_equal(const bosch_locator_bridge__msg__ClientControlMode__Sequence * lhs, const bosch_locator_bridge__msg__ClientControlMode__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientControlMode__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientControlMode__Sequence__copy(
  const bosch_locator_bridge__msg__ClientControlMode__Sequence * input,
  bosch_locator_bridge__msg__ClientControlMode__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__msg__ClientControlMode);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    bosch_locator_bridge__msg__ClientControlMode * data =
      (bosch_locator_bridge__msg__ClientControlMode *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__msg__ClientControlMode__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__msg__ClientControlMode__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientControlMode__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
