// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from bosch_locator_bridge:msg/ClientControlMode.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_CONTROL_MODE__TRAITS_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_CONTROL_MODE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "bosch_locator_bridge/msg/detail/client_control_mode__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace bosch_locator_bridge
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClientControlMode & msg,
  std::ostream & out)
{
  out << "{";
  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: visual_recording_state
  {
    out << "visual_recording_state: ";
    rosidl_generator_traits::value_to_yaml(msg.visual_recording_state, out);
    out << ", ";
  }

  // member: map_state
  {
    out << "map_state: ";
    rosidl_generator_traits::value_to_yaml(msg.map_state, out);
    out << ", ";
  }

  // member: localization_state
  {
    out << "localization_state: ";
    rosidl_generator_traits::value_to_yaml(msg.localization_state, out);
    out << ", ";
  }

  // member: recording_state
  {
    out << "recording_state: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_state, out);
    out << ", ";
  }

  // member: alignment_state
  {
    out << "alignment_state: ";
    rosidl_generator_traits::value_to_yaml(msg.alignment_state, out);
    out << ", ";
  }

  // member: mask_state
  {
    out << "mask_state: ";
    rosidl_generator_traits::value_to_yaml(msg.mask_state, out);
    out << ", ";
  }

  // member: expandmap_state
  {
    out << "expandmap_state: ";
    rosidl_generator_traits::value_to_yaml(msg.expandmap_state, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClientControlMode & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: visual_recording_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "visual_recording_state: ";
    rosidl_generator_traits::value_to_yaml(msg.visual_recording_state, out);
    out << "\n";
  }

  // member: map_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_state: ";
    rosidl_generator_traits::value_to_yaml(msg.map_state, out);
    out << "\n";
  }

  // member: localization_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "localization_state: ";
    rosidl_generator_traits::value_to_yaml(msg.localization_state, out);
    out << "\n";
  }

  // member: recording_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_state: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_state, out);
    out << "\n";
  }

  // member: alignment_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "alignment_state: ";
    rosidl_generator_traits::value_to_yaml(msg.alignment_state, out);
    out << "\n";
  }

  // member: mask_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mask_state: ";
    rosidl_generator_traits::value_to_yaml(msg.mask_state, out);
    out << "\n";
  }

  // member: expandmap_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "expandmap_state: ";
    rosidl_generator_traits::value_to_yaml(msg.expandmap_state, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClientControlMode & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::msg::ClientControlMode & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::msg::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::msg::ClientControlMode & msg)
{
  return bosch_locator_bridge::msg::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::msg::ClientControlMode>()
{
  return "bosch_locator_bridge::msg::ClientControlMode";
}

template<>
inline const char * name<bosch_locator_bridge::msg::ClientControlMode>()
{
  return "bosch_locator_bridge/msg/ClientControlMode";
}

template<>
struct has_fixed_size<bosch_locator_bridge::msg::ClientControlMode>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<bosch_locator_bridge::msg::ClientControlMode>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<bosch_locator_bridge::msg::ClientControlMode>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_CONTROL_MODE__TRAITS_HPP_
