// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientExpandMapVisualization.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_expand_map_visualization__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `zones`
#include "bosch_locator_bridge/msg/detail/client_expand_map_overwrite_zone_information__functions.h"
// Member `prior_map_poses`
#include "geometry_msgs/msg/detail/pose_array__functions.h"
// Member `prior_map_pose_types`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
bosch_locator_bridge__msg__ClientExpandMapVisualization__init(bosch_locator_bridge__msg__ClientExpandMapVisualization * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(msg);
    return false;
  }
  // visualization_id
  // zones
  if (!bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__init(&msg->zones, 0)) {
    bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(msg);
    return false;
  }
  // prior_map_poses
  if (!geometry_msgs__msg__PoseArray__init(&msg->prior_map_poses)) {
    bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(msg);
    return false;
  }
  // prior_map_pose_types
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->prior_map_pose_types, 0)) {
    bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(bosch_locator_bridge__msg__ClientExpandMapVisualization * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // visualization_id
  // zones
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__fini(&msg->zones);
  // prior_map_poses
  geometry_msgs__msg__PoseArray__fini(&msg->prior_map_poses);
  // prior_map_pose_types
  rosidl_runtime_c__int32__Sequence__fini(&msg->prior_map_pose_types);
}

bool
bosch_locator_bridge__msg__ClientExpandMapVisualization__are_equal(const bosch_locator_bridge__msg__ClientExpandMapVisualization * lhs, const bosch_locator_bridge__msg__ClientExpandMapVisualization * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // visualization_id
  if (lhs->visualization_id != rhs->visualization_id) {
    return false;
  }
  // zones
  if (!bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__are_equal(
      &(lhs->zones), &(rhs->zones)))
  {
    return false;
  }
  // prior_map_poses
  if (!geometry_msgs__msg__PoseArray__are_equal(
      &(lhs->prior_map_poses), &(rhs->prior_map_poses)))
  {
    return false;
  }
  // prior_map_pose_types
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->prior_map_pose_types), &(rhs->prior_map_pose_types)))
  {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientExpandMapVisualization__copy(
  const bosch_locator_bridge__msg__ClientExpandMapVisualization * input,
  bosch_locator_bridge__msg__ClientExpandMapVisualization * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // visualization_id
  output->visualization_id = input->visualization_id;
  // zones
  if (!bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__copy(
      &(input->zones), &(output->zones)))
  {
    return false;
  }
  // prior_map_poses
  if (!geometry_msgs__msg__PoseArray__copy(
      &(input->prior_map_poses), &(output->prior_map_poses)))
  {
    return false;
  }
  // prior_map_pose_types
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->prior_map_pose_types), &(output->prior_map_pose_types)))
  {
    return false;
  }
  return true;
}

bosch_locator_bridge__msg__ClientExpandMapVisualization *
bosch_locator_bridge__msg__ClientExpandMapVisualization__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientExpandMapVisualization * msg = (bosch_locator_bridge__msg__ClientExpandMapVisualization *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientExpandMapVisualization), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientExpandMapVisualization));
  bool success = bosch_locator_bridge__msg__ClientExpandMapVisualization__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientExpandMapVisualization__destroy(bosch_locator_bridge__msg__ClientExpandMapVisualization * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__init(bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientExpandMapVisualization * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__msg__ClientExpandMapVisualization *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__msg__ClientExpandMapVisualization), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientExpandMapVisualization__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__fini(bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence *
bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * array = (bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__destroy(bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__are_equal(const bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * lhs, const bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientExpandMapVisualization__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence__copy(
  const bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * input,
  bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__msg__ClientExpandMapVisualization);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    bosch_locator_bridge__msg__ClientExpandMapVisualization * data =
      (bosch_locator_bridge__msg__ClientExpandMapVisualization *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__msg__ClientExpandMapVisualization__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__msg__ClientExpandMapVisualization__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientExpandMapVisualization__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
