// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from bosch_locator_bridge:msg/ClientGlobalAlignVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_VISUALIZATION__TRAITS_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_VISUALIZATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "bosch_locator_bridge/msg/detail/client_global_align_visualization__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'landmarks'
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_visualization_information__traits.hpp"
// Member 'observations'
#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_observation_notice__traits.hpp"

namespace bosch_locator_bridge
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClientGlobalAlignVisualization & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: visualization_id
  {
    out << "visualization_id: ";
    rosidl_generator_traits::value_to_yaml(msg.visualization_id, out);
    out << ", ";
  }

  // member: landmarks
  {
    if (msg.landmarks.size() == 0) {
      out << "landmarks: []";
    } else {
      out << "landmarks: [";
      size_t pending_items = msg.landmarks.size();
      for (auto item : msg.landmarks) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: observations
  {
    if (msg.observations.size() == 0) {
      out << "observations: []";
    } else {
      out << "observations: [";
      size_t pending_items = msg.observations.size();
      for (auto item : msg.observations) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClientGlobalAlignVisualization & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: visualization_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "visualization_id: ";
    rosidl_generator_traits::value_to_yaml(msg.visualization_id, out);
    out << "\n";
  }

  // member: landmarks
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.landmarks.size() == 0) {
      out << "landmarks: []\n";
    } else {
      out << "landmarks:\n";
      for (auto item : msg.landmarks) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: observations
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.observations.size() == 0) {
      out << "observations: []\n";
    } else {
      out << "observations:\n";
      for (auto item : msg.observations) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClientGlobalAlignVisualization & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::msg::ClientGlobalAlignVisualization & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::msg::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::msg::ClientGlobalAlignVisualization & msg)
{
  return bosch_locator_bridge::msg::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::msg::ClientGlobalAlignVisualization>()
{
  return "bosch_locator_bridge::msg::ClientGlobalAlignVisualization";
}

template<>
inline const char * name<bosch_locator_bridge::msg::ClientGlobalAlignVisualization>()
{
  return "bosch_locator_bridge/msg/ClientGlobalAlignVisualization";
}

template<>
struct has_fixed_size<bosch_locator_bridge::msg::ClientGlobalAlignVisualization>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<bosch_locator_bridge::msg::ClientGlobalAlignVisualization>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<bosch_locator_bridge::msg::ClientGlobalAlignVisualization>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_VISUALIZATION__TRAITS_HPP_
